Module EMsgAPI_Functions

    Public Structure Authentication_Credentials
        Public UserId As String
        Public Passcode As String
        Public EM_URL As String
    End Structure

    Public Function EM_Authenticate(ByVal Credentials As Authentication_Credentials) As String
        '   Create XOA Object instance
        Dim EM As EMsgAPI.XOA = New EMsgAPI.XOA

        '   Create Authentication Objects
        Dim authentication As EMsgAPI.Authentication = New EMsgAPI.Authentication
        Dim xddsauth As EMsgAPI.XDDSAuthType = New EMsgAPI.XDDSAuthType

        '   Set RequestID (userid) and Passcode (password)
        xddsauth.Password = Credentials.Passcode
        xddsauth.RequesterID = Credentials.UserId

        '   Set Authentication Object
        authentication.XDDSAuth = xddsauth
        xddsauth = Nothing

        '   Create XOA Reqeust Object
        Dim request As EMsgAPI.Request = New EMsgAPI.Request

        '   Set Request properties
        request.ReceiverKey = Credentials.EM_URL
        request.ResultRequired = EMsgAPI.RequiredType.yes

        '   Set Request Authentication Object
        request.Authentication = authentication
        authentication = Nothing

        '   Setup Object for Authentication Response / Result
        Dim Authenticate_Response As EMsgAPI.AuthenticateResult = New EMsgAPI.AuthenticateResult

        '   Set EM Object parameters
        EM.Url = Credentials.EM_URL ' URL where XML is being posted
        EM.RequestValue = request

        '   Setup Object for Authentication Request
        Dim authrequest As EMsgAPI.AuthenticateRequest = New EMsgAPI.AuthenticateRequest

        Try
            '   Call EMsgAPI Authentication
            Authenticate_Response = EM.Authenticate(authrequest)
            If (Authenticate_Response.Status.StatusCode <> "0") Then
                EM_Authenticate = Authenticate_Response.Status.StatusMessage
            Else
                EM_Authenticate = "Authenticate Successful!"
            End If
        Catch ex As Exception
            EM_Authenticate = ex.Message
        End Try

    End Function

End Module
